import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Sigman.FormationAssist2.Squad";
import "Sigman.FormationAssist2.OptionsPanel";

--- Basic function ---------------------
function AddCallback(object, event, callback)
	if ( object[event] == nil ) then
		object[event] = callback;
	else
		if ( type(object[event]) == "table" ) then
			table.insert(object[event], callback);
		else
			object[event] = {object[event], callback};
		end
	end
end

function RemoveCallback(object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end

LoadSettings();

FAmain = Turbine.UI.Window();
FAmain:SetPosition(200,200);
FAmain:SetSize(1150,890);
FAmain:SetMouseVisible(true);
FAmain:SetBackColor( Turbine.UI.Color( 0, 0, 0 ) );
FAmain:SetZOrder(4);
FAmain:SetVisible(true);

FAmain.window = Turbine.UI.Window();
FAmain.window:SetParent(FAmain);
FAmain.window:SetPosition(0,30);
FAmain.window:SetSize(1136,850);
FAmain.window:SetStretchMode(1);
FAmain.window:SetOpacity(1);
FAmain.window:SetZOrder(3);
FAmain.window:SetMouseVisible(true);
FAmain.window:SetVisible(true);

FAmain.window.map = Turbine.UI.Control();
FAmain.window.map:SetParent(FAmain.window);
FAmain.window.map:SetPosition(0,0);
FAmain.window.map:SetSize(1136,640);
FAmain.window.map:SetStretchMode(1);
FAmain.window.map:SetBackground(settings.MAPimg[1]);
FAmain.window.map:SetZOrder(2);
FAmain.window.map:SetVisible(true);

FAmain.window.Submap = Turbine.UI.Control();
FAmain.window.Submap:SetParent(FAmain.window);
FAmain.window.Submap:SetPosition(0,0);
FAmain.window.Submap:SetSize(1136,640);
FAmain.window.Submap:SetStretchMode(1);
FAmain.window.Submap:SetBackground(settings.BGimg[1][1]);
FAmain.window.Submap:SetZOrder(3);
FAmain.window.Submap:SetVisible(true);

FAmain.window.Side = Turbine.UI.Control();
FAmain.window.Side:SetParent(FAmain.window);
FAmain.window.Side:SetPosition(0,650);
FAmain.window.Side:SetSize(12,200);
FAmain.window.Side:SetStretchMode(1);
FAmain.window.Side:SetBackground("Sigman/FormationAssist2/Resources/side.tga");
FAmain.window.Side:SetZOrder(3);
FAmain.window.Side:SetVisible(true);

FAmain.window.Sub = Turbine.UI.Control();
FAmain.window.Sub:SetPosition(12, 650 );
FAmain.window.Sub:SetSize( 1124, 200 );
FAmain.window.Sub:SetBackground(settings.NoteCover[1][1]);
FAmain.window.Sub:SetParent( FAmain.window );
FAmain.window.Sub:SetZOrder(1);
FAmain.window.Sub:SetVisible(true);
FAmain.window.Sub.idx = 0;

FAmain.icon_window = Turbine.UI.Window();
FAmain.icon_window:SetPosition(1,1);
FAmain.icon_window:SetSize(32,32);
FAmain.icon_window:SetOpacity(0.5);
FAmain.icon_window:SetZOrder(3);
FAmain.icon_window:SetBackground("Sigman/FormationAssist2/Resources/MainIcon.tga");
FAmain.icon_window:SetMouseVisible(true);
FAmain.icon_window:SetVisible(false);

FAmain.map_note = {};
FAmain.map_itemListBox = Turbine.UI.Lotro.TextBox();
FAmain.map_itemListBox:SetPosition( 12, 650 );
FAmain.map_itemListBox:SetSize( 1124, 200 );
FAmain.map_itemListBox:SetFont( Turbine.UI.Lotro.Font.TrajanProBold36 );
FAmain.map_itemListBox:SetParent( FAmain.window );
FAmain.map_itemListBox:SetVisible(false);

FAmain.window.MouseDoubleClick=function(sender,args)
	FAmain.window.Sub:SetVisible(not FAmain.window.Sub:IsVisible());
	FAmain.map_itemListBox:SetVisible(not FAmain.map_itemListBox:IsVisible());
end

FAmain.window.Side.MouseDoubleClick=function(sender,args)
	FAmain.window.Sub:SetVisible(not FAmain.window.Sub:IsVisible());
	FAmain.map_itemListBox:SetVisible(not FAmain.map_itemListBox:IsVisible());
end


FAmain.MoveX=-1;
FAmain.MoveY=-1;

FAmain.MovingIcon=Turbine.UI.Control();
FAmain.MovingIcon:SetParent(FAmain);
FAmain.MovingIcon:SetSize(32,32);
FAmain.MovingIcon:SetStretchMode(1);
FAmain.MovingIcon:SetBackground(0x410081c0)
FAmain.MovingIcon:SetPosition(FAmain:GetWidth()/2-15,FAmain:GetHeight()-21);
FAmain.MovingIcon:SetVisible(false);

FAmain.MouseDown=function(sender,args)
	if (args.Y>FAmain:GetHeight()-15) and (args.X>FAmain:GetWidth()-15) then
		FAmain.MoveX=args.X;
		FAmain.MoveY=args.Y;
		FAmain.MovingIcon:SetLeft(args.X-12);
		FAmain.MovingIcon:SetTop(args.Y-12);
		FAmain.MovingIcon:SetBackground(0x41007e20)
		FAmain.MovingIcon:SetVisible(true);
	elseif (args.Y>FAmain:GetHeight()-15) then
		FAmain.MoveY=args.Y;
		FAmain.MovingIcon:SetLeft(args.X-22);
		FAmain.MovingIcon:SetTop(args.Y-12);
		FAmain.MovingIcon:SetBackground(0x410081c0)
		FAmain.MovingIcon:SetVisible(true);
	elseif (args.X>FAmain:GetWidth()-15) then
		FAmain.MoveX=args.X;
		FAmain.MovingIcon:SetLeft(args.X-12);
		FAmain.MovingIcon:SetTop(args.Y-22);
		FAmain.MovingIcon:SetBackground(0x410081bf)
		FAmain.MovingIcon:SetVisible(true);
	elseif (args.Y<30) then
		FAmain.MoveX=args.X;
		FAmain.MoveY=args.Y;
		FAmain.MovingIcon:SetLeft(args.X-12);
		FAmain.MovingIcon:SetTop(args.Y-12);
		FAmain.MovingIcon:SetSize(32,32);
		FAmain.MovingIcon:SetBackground(0x410000dd)
		FAmain.MovingIcon:SetVisible(true);
	else
		FAmain.MoveX=-1;
		FAmain.MoveY=-1;
	end
end

FAmain.MouseMove=function(sender,args)
	if (FAmain.MoveY>-1 and FAmain.MoveY<30) then
		if (args.X~=FAmain.MoveX or args.Y~= FAmain.MoveY) then
			local newLeft=FAmain:GetLeft()-(FAmain.MoveX-args.X)
			local newTop=FAmain:GetTop()-(FAmain.MoveY-args.Y)
			if newLeft<0 then newLeft=0 end;
			if newLeft>(Turbine.UI.Display.GetWidth()-FAmain:GetWidth()) then newLeft=Turbine.UI.Display.GetWidth()-FAmain:GetWidth() end;
			if newTop<0 then newTop=0 end;
			if newTop>(Turbine.UI.Display.GetHeight()-FAmain:GetHeight()) then newTop=Turbine.UI.Display.GetHeight()-FAmain:GetHeight() end;
			FAmain:SetPosition(newLeft,newTop);
			settings.mainx = newLeft;
			settings.mainy = newTop;
		end
	else		
		if (FAmain.MoveY>-1) then
			if args.Y~= FAmain.MoveY then
				local newHeight=FAmain:GetHeight()-(FAmain.MoveY-args.Y);
				if newHeight<215 then newHeight=215 end;
				if newHeight>(Turbine.UI.Display.GetHeight()-FAmain:GetTop()) then newHeight=Turbine.UI.Display.GetHeight()-FAmain:GetTop() end;
				local newY=args.Y-22;
				if newY<-13 then newY=-13 end
				if newY>(FAmain:GetHeight()-18) then newY=FAmain:GetHeight()-18 end
				FAmain.MovingIcon:SetTop(newY);
				FAmain:SetHeight(newHeight);
				FAmain.MoveY=args.Y;
			end
		end
		if (FAmain.MoveX>-1) then
			if args.X~= FAmain.MoveX then
				local newWidth=FAmain:GetWidth()-(FAmain.MoveX-args.X);
				if newWidth<414 then newWidth=414 end;
				if newWidth>(Turbine.UI.Display.GetWidth()-FAmain:GetLeft()) then newWidth=Turbine.UI.Display.GetWidth()-FAmain:GetLeft() end;
				local newX=args.X-22;
				if newX<-13 then newX=-13 end
				if newX>(FAmain:GetWidth()-18) then newX=FAmain:GetWidth()-18 end
				FAmain.MovingIcon:SetLeft(newX);
				FAmain:SetWidth(newWidth);
				settings.mainw = newWidth;
				FAmain.MoveX=args.X;
			end
		end
	end
end

FAmain.MouseUp=function(sender,args)
	FAmain.MovingIcon:SetVisible(false);
	FAmain.MoveX=-1;
	FAmain.MoveY=-1;
end

FAmain.SetHeight=function(sender,height)
	Turbine.UI.Window.SetHeight(FAmain,height);
	settings.mainh = height;
	-- now move/resize all the controls
	FAmain.MovingIcon:SetTop(height-21);
	FAmain.window:SetSize(FAmain:GetWidth()-14,height-40);
end

FAmain.SetSize=function(sender, width, height)
	Turbine.UI.Window.SetSize(FAmain,width,height);
	settings.mainw = width;
	settings.mainh = height;
	FAmain.window:SetSize(FAmain:GetWidth()-14,FAmain:GetHeight()-40);
end

FAmain.SetWidth=function(sender,width)
	Turbine.UI.Window.SetWidth(FAmain,width);
	settings.mainw = width;
	FAmain.MovingIcon:SetLeft(width-21);
	FAmain.window:SetSize(width-14, FAmain:GetHeight()-40);
end



---------------------------------------------------------------------------------

FAmain.MAPID = 1;

FAmain.window.Submap.MouseDoubleClick=function(sender,args)
		FAmain:SetVisible(false);
		FAmain.icon_window:SetVisible(true);
		settings.visible = false;
end

FAmain.window.Submap.MouseClick=function(sender,args)
	if ( args.Button == Turbine.UI.MouseButton.Right ) and (FAmain.window.pointer == nil) then
	   settings.MAPPointer[FAmain.window.map.idx][ FAmain.window.Sub.idx ][2] = args.X;
	   settings.MAPPointer[FAmain.window.map.idx][ FAmain.window.Sub.idx ][3] = args.Y;
	   FAmain.window.pointer = Turbine.UI.Control();
	   FAmain.window.pointer:SetParent(FAmain.window);
	   FAmain.window.pointer:SetPosition(args.X,args.Y);
	   FAmain.window.pointer:SetSize(30,30);
	   FAmain.window.pointer:SetStretchMode(1);
	   FAmain.window.pointer:SetBackground("Sigman/FormationAssist2/Resources/pointer.tga");
	   FAmain.window.pointer:SetZOrder(100);
	   FAmain.window.pointer:SetVisible(true);
	   FAmain.window.pointer.text = Turbine.UI.Lotro.TextBox();
	   FAmain.window.pointer.text:SetParent(FAmain.window);
	   FAmain.window.pointer.text:SetPosition(args.X,args.Y+30);
	   FAmain.window.pointer.text:SetSize(200,40);
	   FAmain.window.pointer.text:SetMultiline(false);
	   FAmain.window.pointer.text:SetStretchMode(1);
	   FAmain.window.pointer.text:SetZOrder(100);
	   FAmain.window.pointer.text:SetBackColor(Turbine.UI.Color( 0, 0, 0, 0 ));
	   FAmain.window.pointer.text:SetBackColorBlendMode(Overlay);
	   FAmain.window.pointer.text:SetFont( Turbine.UI.Lotro.Font.TrajanProBold36 );
	   FAmain.window.pointer.text:SetText("");
	   FAmain.window.pointer.MouseClick=function(sender,args)
		if ( args.Button == Turbine.UI.MouseButton.Left ) then
		   settings.MAPPointer[FAmain.window.map.idx][ FAmain.window.Sub.idx ][1] = nil;
		   FAmain.window.pointer:SetVisible(false);
		   FAmain.window.pointer.text:SetVisible(false);
	      	   FAmain.window.pointer = nil;
	      	end
	   end
	   FAmain.window.pointer.text.FocusLost=function(sender, args)
		   settings.MAPPointer[FAmain.window.map.idx][ FAmain.window.Sub.idx ][1] = FAmain.window.pointer.text:GetText();
	   end

	end
end



FAmain:SetWidth(settings.mainw);
FAmain:SetHeight(settings.mainh);
FAmain.icon_window:SetVisible(not settings.visible);
FAmain:SetVisible(settings.visible);
FAmain.map_itemListBox:SetText( settings.MAPNote[1][1] );
FAmain.window.map.idx = 1;
FAmain.window.Sub.idx = 1;



---------------------------------------------------------------------------------

FAmain.Map_menu = Turbine.UI.ContextMenu();
map_items = FAmain.Map_menu:GetItems();

for i = 1 , table.maxn(settings.MAP) do
    map_item = Turbine.UI.MenuItem(settings.MAP[i]);
    map_item.Click = function(sender, args)
    		   settings.MAPNote[FAmain.window.map.idx][ FAmain.window.Sub.idx ] = FAmain.map_itemListBox:GetText();
	 	   if FAmain.window.pointer == nil then
	    	      	settings.MAPPointer[FAmain.window.map.idx][ FAmain.window.Sub.idx ][1] = nil;
	 	   else
		   	FAmain.window.pointer:SetVisible(false);
		   	FAmain.window.pointer.text:SetVisible(false);
	      	   	FAmain.window.pointer = nil;
	 	   end
		   FAmain.window.map.idx = i;
		   FAmain.window.Sub.idx = 1;
		   FAmain.window.map:SetBackground(settings.MAPimg[i]);
		   FAmain.window.Submap:SetBackground(settings.BGimg[i][1]);
		   FAmain.map_itemListBox:SetText( settings.MAPNote[i][1] );
		   UpdatePointer(i,1);

		   FAmain.window.Sub:SetBackground(settings.NoteCover[i][1]);

		   sub_items = FAmain.SubMap_menu:GetItems();
		   sub_items:Clear();
		   FAmain.window.Sub:SetBackground(settings.NoteCover[i][1]);
		   for j = 1 , table.maxn(settings.SubMAP[i]) do
    		       sub_item = Turbine.UI.MenuItem(settings.SubMAP[i][j]);
    		       sub_item.Click = function(sender, args)
    		       		      settings.MAPNote[FAmain.window.map.idx][ FAmain.window.Sub.idx ] = FAmain.map_itemListBox:GetText();
	 	   		      if FAmain.window.pointer == nil then
	    	      		      	 settings.MAPPointer[FAmain.window.map.idx][ FAmain.window.Sub.idx ][1] = nil;
	 	   		      else
					FAmain.window.pointer:SetVisible(false);
		   	   		FAmain.window.pointer.text:SetVisible(false);
	      	   	   		FAmain.window.pointer = nil;
	 	   		      end

		   		      FAmain.window.Submap:SetBackground(settings.BGimg[FAmain.window.map.idx][j]);

		   		      FAmain.map_itemListBox:SetText( settings.MAPNote[FAmain.window.map.idx][j] );
		   		      UpdatePointer(FAmain.window.map.idx,j);
		   		      FAmain.window.Sub.idx = j;

		   		      FAmain.window.Sub:SetBackground(settings.NoteCover[FAmain.window.map.idx][j]);
    	    		end
    	    		sub_items:Add(sub_item);
		   end
    end
    map_items:Add(map_item);
end


function Mapselect(sender, args)
	 if ( args.Button == Turbine.UI.MouseButton.Left ) then
	    FAmain.Map_menu:ShowMenu();
	 end
end


FAmain.SubMap_menu = Turbine.UI.ContextMenu();
sub_items = FAmain.SubMap_menu:GetItems();

for i = 1 , table.maxn(settings.SubMAP[FAmain.window.map.idx]) do
    sub_item = Turbine.UI.MenuItem(settings.SubMAP[FAmain.window.map.idx][i]);
    sub_item.Click = function(sender, args)
    		   settings.MAPNote[FAmain.window.map.idx][ FAmain.window.Sub.idx ] = FAmain.map_itemListBox:GetText();
	 	   if FAmain.window.pointer == nil then
	    	      	settings.MAPPointer[FAmain.window.map.idx][ FAmain.window.Sub.idx ][1] = nil;
	 	   else
		   	FAmain.window.pointer:SetVisible(false);
		   	FAmain.window.pointer.text:SetVisible(false);
	      	   	FAmain.window.pointer = nil;
	 	   end
		   FAmain.map_itemListBox:SetText( settings.MAPNote[FAmain.window.map.idx][i] );
		   UpdatePointer(FAmain.window.map.idx,i);
		   FAmain.window.Sub.idx = i;
		   FAmain.window.Submap:SetBackground(settings.BGimg[FAmain.window.map.idx][i]);
		   FAmain.window.Sub:SetBackground(settings.NoteCover[FAmain.window.map.idx][i]);
		   FAmain.btn5.slt:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, settings.Squad[FAmain.window.map.idx][i][0][0] ));
    end
    sub_items:Add(sub_item);
end	


FAmain.Opacity_menu = Turbine.UI.ContextMenu();
op_items = FAmain.Opacity_menu:GetItems();

op_item = Turbine.UI.MenuItem("Hide");
op_item.Click = function(sender, args) 
	FAmain:SetVisible(false);
	FAmain.icon_window:SetVisible(true);
	settings.visible = false;
end

op_items:Add(op_item);


for i = 2, 10 do
    op_item = Turbine.UI.MenuItem(i/10);
    op_item.Click = function( sender, args )
    		  FAmain:SetOpacity(i/10);
    		  FAmain.window:SetOpacity(i/10);
		  FAmain.window.map:SetOpacity(i/10);
	 	  FAmain.window.Submap:SetOpacity(i/10);
	 	  FAmain.map_itemListBox:SetOpacity(i/10);
		  FAmain.window.Side:SetOpacity(i/10);

    end
    op_items:Add(op_item);
end



function SubMapSelect(sender, args)
	 if ( args.Button == Turbine.UI.MouseButton.Left ) then
	    FAmain.SubMap_menu:ShowMenu();
	 end
end



function Opacity(sender, args)
	 if ( args.Button == Turbine.UI.MouseButton.Left ) then
	    FAmain.Opacity_menu:ShowMenu();
	 end
end


---------------- Icon window setting start -----------------------------
FAmain.icon_window.MoveX=-1;
FAmain.icon_window.MoveY=-1;
FAmain.icon_window.Moving=false;
FAmain.icon_window.DefaultOpacity=0.3;

FAmain.icon_window.MouseClick = function(sender,args)
	if FAmain.icon_window.Moving then
	   FAmain.icon_window.Moving=false;
	   FAmain.icon_window.MoveX=-1;
	else
	   FAmain.icon_window:SetVisible(false);
	   FAmain:SetVisible(true);
	   settings.visible = true;
	end
end

FAmain.icon_window.MouseEnter=function(sender,args)
	FAmain.icon_window:SetOpacity(1);
end

FAmain.icon_window.MouseLeave=function(sender,args)
	FAmain.icon_window:SetOpacity(FAmain.icon_window.DefaultOpacity);
end

FAmain.icon_window.MouseDown=function(sender,args)
	FAmain.icon_window.MoveX=args.X;
	FAmain.icon_window.MoveY=args.Y;
end

FAmain.icon_window.MouseUp=function(sender,args)
	FAmain.icon_window.MoveX=-1;
	FAmain.icon_window.MoveY=-1;
end

FAmain.icon_window.MouseMove=function(sender,args)
	if FAmain.icon_window.MoveX~=-1 and (args.X~=FAmain.icon_window.MoveX or args.Y~= FAmain.icon_window.MoveY) then
	   FAmain.icon_window.Moving=true;
	   FAmain.icon_newLeft=FAmain.icon_window:GetLeft()-(FAmain.icon_window.MoveX-args.X)
	   FAmain.icon_newTop=FAmain.icon_window:GetTop()-(FAmain.icon_window.MoveY-args.Y)
	   if FAmain.icon_newLeft<0 then FAmain.icon_newLeft=0 end;
	   if FAmain.icon_newLeft>(Turbine.UI.Display.GetWidth()-FAmain.icon_window:GetWidth()) then FAmain.icon_newLeft=Turbine.UI.Display.GetWidth()-FAmain.icon_window:GetWidth() end;
	   if FAmain.icon_newTop<0 then FAmain.icon_newTop=0 end;
	   if FAmain.icon_newTop>(Turbine.UI.Display.GetHeight()-FAmain.icon_window:GetHeight()) then FAmain.icon_newTop=Turbine.UI.Display.GetHeight()-FAmain.icon_window:GetHeight() end;
	   FAmain.icon_window:SetPosition(FAmain.icon_newLeft,FAmain.icon_newTop);
	   settings.icony = FAmain.icon_newTop;
	   settings.iconx = FAmain.icon_newLeft;
	end
end

---------------- Icon window setting end -----------------------------

FAmain.btn1 = Turbine.UI.Lotro.Button();
FAmain.btn1:SetParent(FAmain);
FAmain.btn1:SetSize(70,20);
FAmain.btn1:SetPosition(5,5);
FAmain.btn1:SetText("Map");
FAmain.btn1:SetMouseVisible(true);
FAmain.btn1:SetOpacity(1);
FAmain.btn1.MouseClick = Mapselect;

FAmain.btn2 = Turbine.UI.Lotro.Button();
FAmain.btn2:SetParent(FAmain);
FAmain.btn2:SetSize(70,20);
FAmain.btn2:SetPosition(80,5);
FAmain.btn2:SetText("Sub Map");
FAmain.btn2:SetMouseVisible(true);
FAmain.btn2:SetOpacity(1);
FAmain.btn2.MouseClick = SubMapSelect;

FAmain.btn3 = Turbine.UI.Lotro.Button();
FAmain.btn3:SetParent(FAmain);
FAmain.btn3:SetSize(70,20);
FAmain.btn3:SetPosition(155,5);
FAmain.btn3:SetText("Squad");
FAmain.btn3:SetMouseVisible(true);
FAmain.btn3:SetOpacity(1);
FAmain.btn3.MouseClick = MakeSquad;

FAmain.btn4 = Turbine.UI.Lotro.Button();
FAmain.btn4:SetParent(FAmain);
FAmain.btn4:SetSize(70,20);
FAmain.btn4:SetPosition(230,5);
FAmain.btn4:SetText("Opacity");
FAmain.btn4:SetMouseVisible(true);
FAmain.btn4:SetOpacity(1);
FAmain.btn4.MouseClick = Opacity;

FAmain.btn5 = Turbine.UI.Control();
FAmain.btn5:SetParent(FAmain);
FAmain.btn5:SetSize(60,20);
FAmain.btn5:SetPosition(305,5);
FAmain.btn5:SetBackground("Sigman/FormationAssist2/Resources/SEND.tga");
FAmain.btn5:SetMouseVisible(false);
FAmain.btn5:SetOpacity(1);
FAmain.btn5:SetZOrder(10000);

FAmain.btn5.slt = Turbine.UI.Lotro.Quickslot();
FAmain.btn5.slt:SetParent(FAmain);
FAmain.btn5.slt:SetSize(60,20);
FAmain.btn5.slt:SetPosition(305,5);
FAmain.btn5.slt:SetZOrder(1);
FAmain.btn5.slt:SetVisible(true);

FAmain.btn5.slt:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, ""));


FACmd = Turbine.ShellCommand();

function FACmd:Execute(cmd, args)
	 if args == "show" then
	 	FAmain:SetVisible(true);
		FAmain.icon_window:SetVisible(false);
		settings.visible = true;
	 elseif args == "hide" then
	 	FAmain:SetVisible(false);
		FAmain.icon_window:SetVisible(true);
		settings.visible = false;
	 elseif (args == "toggle") or (args == "") then
		FAmain.icon_window:SetVisible(settings.visible);
		settings.visible = not settings.visible;
	 	FAmain:SetVisible(settings.visible);
	 end
end

Turbine.Shell.AddCommand("f-assist", FACmd);
Turbine.Shell.WriteLine("usage:");
Turbine.Shell.WriteLine("  /f-assist");
Turbine.Shell.WriteLine("       Toggle Formation Assist.");
Turbine.Shell.WriteLine("  /f-assist (show|Hide|toggle)");
Turbine.Shell.WriteLine("       Show, Hide or Toggle Formation Assist.");


Turbine.Plugin.Unload = function (sender, args)
	SaveSettings();
end

BuildOPPanel();

UpdatePointer(FAmain.window.map.idx, FAmain.window.Sub.idx);


plugin.GetOptionsPanel = function( self )
  return optionsPanel;
end
