import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";


function LoadSettings()
	temp_version = Plugins.FormationAssist2:GetVersion();
	settings = Turbine.PluginData.Load( Turbine.DataScope.Account, "FormationAssist2" );
	if (type( settings ) ~= "table") or (settings.version < "0.2.0") then
	   	if type( settings ) == "table" then
	 	   Turbine.PluginData.Save( Turbine.DataScope.Account, "FormationAssist2_old" , settings );
		end
		settings={};
		settings.version = temp_version;
		settings.mainx = 200;
		settings.mainy = 200;
		settings.mainw = 580;
		settings.mainh = 450;
		settings.visible = true;
		settings.iconx = 1;
		settings.icony = 1;
		settings.MAP = {};
		settings.MAP[1] = "Deeping Wall";
		settings.MAPimg = {};
		settings.MAPimg[1] = "Sigman/FormationAssist2/Map/Deeping_wall.tga";
		settings.SubMAP = {};
		settings.SubMAP[1] = {};
		settings.SubMAP[1][1] = "Main Map";
		settings.SubMAP[1][2] = "A Flanking Foe";
		settings.SubMAP[1][3] = "Assault on the East Tower";
		settings.SubMAP[1][4] = "Breaching the Hornburg";
		settings.SubMAP[1][5] = "Bred for Battle";
		settings.SubMAP[1][6] = "Securing the Culvert";
		settings.SubMAP[1][7] = "Shells in the Air";
		settings.SubMAP[1][8] = "Siege Under Fire";
		settings.SubMAP[1][9] = "The vanguard Defilers";
		settings.SubMAP[1][10] = "Vandals in the Tower";
		settings.BGimg = {};
		settings.BGimg[1] = {};
		settings.BGimg[1][1] = "Sigman/FormationAssist2/Map/Deeping_wall2.tga";
		settings.BGimg[1][2] = "Sigman/FormationAssist2/Map/A-Flanking-Foe.tga";
		settings.BGimg[1][3] = "Sigman/FormationAssist2/Map/Assault-on-the-East-Tower.tga";
		settings.BGimg[1][4] = "Sigman/FormationAssist2/Map/Breaching-the-Hornburg.tga";
		settings.BGimg[1][5] = "Sigman/FormationAssist2/Map/Bred-for-Battle.tga";
		settings.BGimg[1][6] = "Sigman/FormationAssist2/Map/Securing-the-Culvert.tga";
		settings.BGimg[1][7] = "Sigman/FormationAssist2/Map/Shells-in-the-Air.tga";
		settings.BGimg[1][8] = "Sigman/FormationAssist2/Map/Siege-Under-Fire.tga";
		settings.BGimg[1][9] = "Sigman/FormationAssist2/Map/The-vanguard-Defilers.tga";
		settings.BGimg[1][10] = "Sigman/FormationAssist2/Map/Vandals-in-the-Tower.tga";
		settings.MAPNote = {};
		settings.MAPNote[1] = {};
		settings.NoteCover = {};
		settings.NoteCover[1] = {};
		settings.Squad = {};
		settings.Squad[1] = {};
		for i =1 ,10 do
		    settings.NoteCover[1][i] = "Sigman/FormationAssist2/Map/turn.tga";
		    settings.Squad[1][i] = {};
		    settings.Squad[1][i][0] = {};
		end
	end
	if settings.MAPPointer == nil then
		settings.MAPPointer = {};
		for i=1, table.maxn(settings.MAP) do
		    settings.MAPPointer[i] = {};
		    for j =1, table.maxn(settings.SubMAP[i]) do
		    	settings.MAPPointer[i][j] = {};
		    end
		end
	end
	settings.version = temp_version;
	return settings;
end

function SaveSettings()
	 settings.MAPNote[FAmain.window.map.idx][ FAmain.window.Sub.idx ] = FAmain.map_itemListBox:GetText();
	 Turbine.PluginData.Save( Turbine.DataScope.Account, "FormationAssist2", settings );
end



function BuildOPPanel()
--------------------------------------------------------------

optionsPanel = Turbine.UI.ListBox();
optionsPanel:SetBackColor( Turbine.UI.Color( 0, 0, 0 ) );
optionsPanel:SetSize( 800, 600 );
optionsPanel:SetOrientation(Turbine.UI.Orientation.Horizontal);
optionsPanel:SetMaxItemsPerLine(1);

MapID = 1;
SMapID = 1;

function UpdatePointer(MID,SMID)
		if settings.MAPPointer[MID][SMID][1] == nil then
	 		if FAmain.window.pointer ~= nil then
		   	   FAmain.window.pointer:SetVisible(false);
		   	   FAmain.window.pointer.text:SetVisible(false);
	      	   	   FAmain.window.pointer = nil;
			end
		else
		   	   FAmain.window.pointer = Turbine.UI.Control();
	   		   FAmain.window.pointer:SetParent(FAmain.window);
	   		   FAmain.window.pointer:SetPosition(settings.MAPPointer[MID][SMID][2],settings.MAPPointer[MID][SMID][3]);
	   		   FAmain.window.pointer:SetSize(30,30);
	   		   FAmain.window.pointer:SetStretchMode(1);
	   		   FAmain.window.pointer:SetBackground("Sigman/FormationAssist2/Resources/pointer.tga");
	   		   FAmain.window.pointer:SetZOrder(100);
	   		   FAmain.window.pointer:SetVisible(true);
	   		   FAmain.window.pointer.text = Turbine.UI.Lotro.TextBox();
	   		   FAmain.window.pointer.text:SetParent(FAmain.window);
	   		   FAmain.window.pointer.text:SetPosition(settings.MAPPointer[MID][SMID][2],settings.MAPPointer[MID][SMID][3]+30);
	   		   FAmain.window.pointer.text:SetSize(200,40);
	   		   FAmain.window.pointer.text:SetMultiline(false);
	   		   FAmain.window.pointer.text:SetStretchMode(1);
	   		   FAmain.window.pointer.text:SetZOrder(100);
	   		   FAmain.window.pointer.text:SetBackColor(Turbine.UI.Color( 0, 0, 0, 0 ));
	  		   FAmain.window.pointer.text:SetBackColorBlendMode(Overlay);
	   		   FAmain.window.pointer.text:SetFont( Turbine.UI.Lotro.Font.TrajanProBold36 );
	   		   FAmain.window.pointer.text:SetText(settings.MAPPointer[MID][SMID][1]);
	   		   FAmain.window.pointer.MouseClick=function(sender,args)
				if ( args.Button == Turbine.UI.MouseButton.Left ) then
		   		   settings.MAPPointer[FAmain.window.map.idx][ FAmain.window.Sub.idx ][1] = nil;
		   	      	   FAmain.window.pointer:SetVisible(false);
		   	      	   FAmain.window.pointer.text:SetVisible(false);
	      	   	      	   FAmain.window.pointer = nil;
				end   
	      		   end
		end
end

function ChangeMap(MID)
	     	FAmain.window.map:SetBackground(settings.MAPimg[MID]);
		FAmain.window.Submap:SetBackground(settings.BGimg[MID][1]);
		FAmain.map_itemListBox:SetText( settings.MAPNote[MID][1] );
		FAmain.window.Sub:SetBackground(settings.NoteCover[MID][1]);
		UpdatePointer(MID,1);
		map_items = FAmain.Map_menu:GetItems();
		map_items:Clear();

		for i = 1 , table.maxn(settings.MAP) do
      	     		map_item = Turbine.UI.MenuItem(settings.MAP[i]);
    	     		map_item.Click = function(sender, args)
		     	        FAmain.window.map:SetBackground(settings.MAPimg[i]);
				sub_items = FAmain.SubMap_menu:GetItems();
		   		sub_items:Clear();
				for j = 1 , table.maxn(settings.SubMAP[i]) do
				      sub_item = Turbine.UI.MenuItem(settings.SubMAP[i][j]);
    		       		      sub_item.Click = function(sender, args)
    		       		      	       settings.MAPNote[i][ FAmain.window.Sub.idx ] = FAmain.map_itemListBox:GetText();
		   		      	       FAmain.window.Submap:SetBackground(settings.BGimg[i][j]);
		   		      	       FAmain.map_itemListBox:SetText( settings.MAPNote[i][j] );
					       FAmain.window.Sub:SetBackground(settings.NoteCover[i][j]);
	 				       if FAmain.window.pointer == nil then
	    				       	  settings.MAPPointer[i][ FAmain.window.Sub.idx ][1] = nil;
	 				       else
		   	   		       	  FAmain.window.pointer:SetVisible(false);
		   	   			  FAmain.window.pointer.text:SetVisible(false);
	      	   	   			  FAmain.window.pointer = nil;
	    				       end
					       UpdatePointer(i,j);
    	    			      end
    	    			sub_items:Add(sub_item);
		   		end
    			end
			map_items:Add(map_item);
		end



		sub_items = FAmain.SubMap_menu:GetItems();
		sub_items:Clear();
		for i = 1 , table.maxn(settings.SubMAP[MID]) do
    		       sub_item = Turbine.UI.MenuItem(settings.SubMAP[MID][i]);
    		       sub_item.Click = function(sender, args)
    		       		      settings.MAPNote[FAmain.window.map.idx][ FAmain.window.Sub.idx ] = FAmain.map_itemListBox:GetText();
		   		      FAmain.map_itemListBox:SetText( settings.MAPNote[FAmain.window.map.idx][i] );
		   		      FAmain.window.Submap:SetBackground(settings.BGimg[FAmain.window.map.idx][i]);
	 			      if FAmain.window.pointer == nil then
	    				       	  settings.MAPPointer[FAmain.window.map.idx][ FAmain.window.Sub.idx ][1] = nil;
	 			      else
		   	   		       	  FAmain.window.pointer:SetVisible(false);
		   	   			  FAmain.window.pointer.text:SetVisible(false);
	      	   	   			  FAmain.window.pointer = nil;
	    			      end
				      UpdatePointer(FAmain.window.map.idx,i);
		   		      FAmain.window.Sub.idx = i;
		   		      FAmain.window.Sub:SetBackground(settings.NoteCover[FAmain.window.map.idx][i]);

    	    		end
    	    		sub_items:Add(sub_item);
		end


		listItem = optionsPanel:GetItem(2);
		listItem.line2_2_1:SetText(settings.MAP[MID]);
		optionsPanel:SetItem(2, listItem );
		listItem = optionsPanel:GetItem(3);
		listItem.line3_2:SetText(settings.MAPimg[MID]);
		optionsPanel:SetItem(3, listItem );

		local listItem = Turbine.UI.Control();
      		listItem:SetSize( 400, 250 );
        	listItem.line7 = Turbine.UI.ListBox();
      		listItem.line7:SetParent( listItem );
      		listItem.line7:SetBackColor( Turbine.UI.Color( 0.2, 0.2, 0.2 ) );
      		listItem.line7:SetSize( 300, 240 );
		listItem.line7:SetPosition(100,0);
		listItem.line7_2 = {};
		for i = 1, table.maxn(settings.SubMAP[MID]) do
            	    local listItem1 = Turbine.UI.Control();
            	    listItem1:SetSize( 300, 20 );
            	    listItem1:SetBackColor( Turbine.UI.Color(  0.2, 0.2, 0.2) );
		    listItem1.Qty=Turbine.UI.Label();
		    listItem1.Qty:SetParent(listItem1);
		    listItem1.Qty:SetSelectable( true );
		    listItem1.Qty:SetSize(300,20);
		    listItem1.Qty:SetTop(1);
		    listItem1.Qty:SetFont(Turbine.UI.Lotro.Font.Verdana16);
		    listItem1.Qty:SetText( settings.SubMAP[MID][i]);
    		    listItem1.Qty.MouseClick = function(sender, args)
        	    	if (args.Button == Turbine.UI.MouseButton.Left) then
			   listItem = optionsPanel:GetItem(7);
			   listItem.line7_2[SMapID]:SetVisible(false);
      			   listItem.line7_2[SMapID]:SetBackColor( Turbine.UI.Color( 0.2, 0.2, 0.2 ) );
            		   SMapID = listItem.line7:GetSelectedIndex();
			   listItem.line7_2[SMapID]:SetVisible(true);
      			   listItem.line7_2[SMapID]:SetBackColor( Turbine.UI.Color( 106/255, 90/255, 205/255 ) );
			   listItem8 = optionsPanel:GetItem(8);
			   listItem8.line8_2:SetText(settings.BGimg[MapID][SMapID]);
			   optionsPanel:SetItem(8, listItem8 );
			   listItem9 = optionsPanel:GetItem(9);
			   listItem9.line9_2:SetText(settings.NoteCover[MapID][SMapID]);
			   optionsPanel:SetItem(9, listItem9 );
		    	end
		    end		   
            	    listItem.line7:AddItem( listItem1 );
		    listItem.line7_2[i] = Turbine.UI.TextBox();
	    	    listItem.line7_2[i]:SetMultiline(false);
      	   	    listItem.line7_2[i]:SetParent( listItem );
      	    	    listItem.line7_2[i]:SetBackColor( Turbine.UI.Color( 0.2, 0.2, 0.2 ) );
      	    	    listItem.line7_2[i]:SetSize( 300, 20 );
	    	    listItem.line7_2[i]:SetPosition(100,(i-1)*20);
	    	    listItem.line7_2[i]:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	    	    listItem.line7_2[i]:SetText( settings.SubMAP[MapID][i]);
	    	    listItem.line7_2[i]:SetVisible(false);
		end
		listItem.line7_2[SMapID]:SetVisible(true);
      		listItem.line7_2[SMapID]:SetBackColor( Turbine.UI.Color( 106/255, 90/255, 205/255 ) );
 		optionsPanel:SetItem(7, listItem );

		listItem = optionsPanel:GetItem(8);
		listItem.line8_2:SetText(settings.BGimg[MID][SMapID]);
		optionsPanel:SetItem(8, listItem );
		listItem = optionsPanel:GetItem(9);
		listItem.line9_2:SetText(settings.NoteCover[MID][SMapID]);
		optionsPanel:SetItem(9, listItem );
end

function NewMap(sender, args)
	 i = table.maxn(settings.MAP)+1;
	 settings.SubMAP[i] = {};
	 settings.SubMAP[i][1] = "New Sub Map";
	 settings.BGimg[i] = {};
	 settings.Squad[i] = {};
	 settings.Squad[i][1] = {};
	 settings.Squad[i][1][0] = {};
	 settings.MAPNote[i] = {};
	 settings.MAPPointer[i] = {};
	 settings.MAPPointer[i][1] = {};

	 settings.NoteCover[i] = {};
	 settings.MAP[i] = optionsPanel:GetItem(2).line2_2_1:GetText();
	 settings.MAPimg[i] = optionsPanel:GetItem(3).line3_2:GetText();
	 FAmain.window.map:SetBackground(settings.MAPimg[i]);
	 MapID = i;
	 SMapID  = 1;
	 ChangeMap(i);
	 local items = Map_menu:GetItems();
	 items:Clear();
	 for j = 1, table.maxn(settings.MAP) do
     	     items:Add(Turbine.UI.MenuItem(settings.MAP[j]));
     	     items:Get(j).Click = function(sender, args)
     	    			MapID = j;
 				ChangeMap(j);
	     end
	 end    
end

function MapEdit(sender, args)
	 settings.MAP[MapID] = optionsPanel:GetItem(2).line2_2_1:GetText();
	 settings.MAPimg[MapID] = optionsPanel:GetItem(3).line3_2:GetText();
	 FAmain.window.map:SetBackground(settings.MAPimg[MapID]);
	 ChangeMap(MapID);
	 local items = Map_menu:GetItems();
	 items:Clear();
	 for j = 1, table.maxn(settings.MAP) do
     	     items:Add(Turbine.UI.MenuItem(settings.MAP[j]));
     	     items:Get(j).Click = function(sender, args)
    			MapID = j;
      			ChangeMap(j);
	     end
	 end    
end

function DelMap(sender, args)
	 table.remove(settings.MAP, MapID);
	 table.remove(settings.NoteCover, MapID);
	 table.remove(settings.MAPNote, MapID);
	 table.remove(settings.MAPPointer, MapID);
	 table.remove(settings.MAPimg, MapID);
	 table.remove(settings.SubMAP, MapID);
	 table.remove(settings.BGimg, MapID);
	 table.remove(settings.Squad, MapID);
	 MapID = 1;
	 ChangeMap(1);
	 local items = Map_menu:GetItems();
	 items:Clear();
	 for j = 1, table.maxn(settings.MAP) do
     	     items:Add(Turbine.UI.MenuItem(settings.MAP[j]));
     	     items:Get(j).Click = function(sender, args)
     	    			MapID = j;
 				ChangeMap(j);
	     end
	 end    
end

function NewSMap(sender, args)
	 i = table.maxn(settings.SubMAP[MapID])+1;
	 settings.SubMAP[MapID][i] = optionsPanel:GetItem(7).line7_2[SMapID]:GetText();
	 settings.BGimg[MapID][i] = optionsPanel:GetItem(8).line8_2:GetText();
	 settings.NoteCover[MapID][i] = optionsPanel:GetItem(9).line9_2:GetText();
	 settings.MAPNote[MapID][i] = "";
	 settings.MAPPointer[MapID][i] = {};
	 settings.Squad[MapID][i] = {};
	 settings.Squad[MapID][i][0] = {};
	 SMapID  = i;
	 ChangeMap(MapID);
end

function SMapEdit(sender, args)
	 settings.SubMAP[MapID][SMapID] = optionsPanel:GetItem(7).line7_2[SMapID]:GetText();
	 settings.BGimg[MapID][SMapID] = optionsPanel:GetItem(8).line8_2:GetText();
	 settings.NoteCover[MapID][SMapID] = optionsPanel:GetItem(9).line9_2:GetText();
	 ChangeMap(MapID);
end

function DelSMap(sender, args)
	 table.remove(settings.SubMAP[MapID], SMapID);
	 table.remove(settings.BGimg[MapID], SMapID);
	 table.remove(settings.NoteCover[MapID], SMapID);
	 table.remove(settings.MAPNote[MapID], SMapID);
	 table.remove(settings.MAPPointer[MapID], SMapID);
	 table.remove(settings.Squad[MapID], SMapID);
	 ChangeMap(MapID);
end

function SMapUp(sender, args)
	 if (SMapID > 1) then
	 cSubMAP = settings.SubMAP[MapID][SMapID];
	 settings.SubMAP[MapID][SMapID] = settings.SubMAP[MapID][SMapID-1];
	 settings.SubMAP[MapID][SMapID-1] = cSubMAP;
	 cBGimg = settings.BGimg[MapID][SMapID];
	 settings.BGimg[MapID][SMapID] = settings.BGimg[MapID][SMapID-1];
	 settings.BGimg[MapID][SMapID-1] = cBGimg;
	 cNoteCover = settings.NoteCover[MapID][SMapID];
	 settings.NoteCover[MapID][SMapID] = settings.NoteCover[MapID][SMapID-1];
	 settings.NoteCover[MapID][SMapID-1] = cNoteCover;
	 cMAPNote = settings.MAPNote[MapID][SMapID];
	 settings.MAPNote[MapID][SMapID] = settings.MAPNote[MapID][SMapID-1];
	 settings.MAPNote[MapID][SMapID-1] = cMAPNote;
	 SMapID = SMapID - 1;
	 ChangeMap(MapID);
	 end
end

function SMapDown(sender, args)
	 if (SMapID < table.maxn(settings.SubMAP[MapID])) then
	 cSubMAP = settings.SubMAP[MapID][SMapID];
	 settings.SubMAP[MapID][SMapID] = settings.SubMAP[MapID][SMapID+1];
	 settings.SubMAP[MapID][SMapID+1] = cSubMAP;
	 cBGimg = settings.BGimg[MapID][SMapID];
	 settings.BGimg[MapID][SMapID] = settings.BGimg[MapID][SMapID+1];
	 settings.BGimg[MapID][SMapID+1] = cBGimg;
	 cNoteCover = settings.NoteCover[MapID][SMapID];
	 settings.NoteCover[MapID][SMapID] = settings.NoteCover[MapID][SMapID+1];
	 settings.NoteCover[MapID][SMapID+1] = cNoteCover;
	 cMAPNote = settings.MAPNote[MapID][SMapID];
	 settings.MAPNote[MapID][SMapID] = settings.MAPNote[MapID][SMapID+1];
	 settings.MAPNote[MapID][SMapID+1] = cMAPNote;
	 SMapID = SMapID + 1;
	 ChangeMap(MapID);
	 end
end


Map_menu = Turbine.UI.ContextMenu()
local items = Map_menu:GetItems();
for i = 1, table.maxn(settings.MAP) do
     items:Add(Turbine.UI.MenuItem(settings.MAP[i]));
     items:Get(i).Click = function(sender, args)
     			MapID = i;
			SMapID = 1;
     			ChangeMap(i);
     end
end    


local listItem = Turbine.UI.Control();
      listItem:SetSize( 400, 35 );
      	listItem.line1=Turbine.UI.Label();
	listItem.line1:SetFont(Turbine.UI.Lotro.Font.TrajanPro24);
      	listItem.line1:SetParent(listItem);
	listItem.line1:SetSize(400,30);
	listItem.line1:SetText("Main MAP");
	listItem.line1:SetForeColor(Turbine.UI.Color(221/255, 160/255, 221/255));
    	listItem.line1:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
    	listItem.line1:SetFontStyle(Turbine.UI.FontStyle.Outline);
    	listItem.line1:SetOutlineColor(Turbine.UI.Color(0, 0, 0));
    	listItem.line1:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend);
      optionsPanel:AddItem( listItem );

local listItem = Turbine.UI.Control();
      listItem:SetSize( 400, 25 );
      	listItem.line2_1=Turbine.UI.Label();
	listItem.line2_1:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
      	listItem.line2_1:SetParent(listItem);
	listItem.line2_1:SetSize(100,25);
	listItem.line2_1:SetText("MAP");

      	listItem.line2_2 = Turbine.UI.Label();
      	listItem.line2_2:SetParent(listItem)
	listItem.line2_2:SetPosition(150,0);
	listItem.line2_2:SetSize(202,22);
	listItem.line2_2:SetBackColor( Turbine.UI.Color(164/256, 120/256, 1/256) );

      	listItem.line2_2_1 = Turbine.UI.TextBox();
      	listItem.line2_2_1:SetParent(listItem.line2_2)
	listItem.line2_2_1:SetPosition(1,1);
	listItem.line2_2_1:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
	listItem.line2_2_1:SetSize(185,20);
	listItem.line2_2_1:SetMultiline(false);
	listItem.line2_2_1:SetText(settings.MAP[MapID]);
	listItem.line2_2_1:SetBackColor( Turbine.UI.Color(0, 0, 0) );

      	listItem.line2_2_2= Turbine.UI.Control();
      	listItem.line2_2_2:SetParent(listItem.line2_2)
	listItem.line2_2_2:SetPosition(186,0);
	listItem.line2_2_2:SetSize(14,14);
	listItem.line2_2_2:SetBackground(0x41007e18);
	listItem.line2_2_2:SetStretchMode(2);
	listItem.line2_2_2.MouseDown=function(sender,args)
	 if ( args.Button == Turbine.UI.MouseButton.Left ) then
	    Map_menu:ShowMenu();
	 end
	end

      optionsPanel:AddItem( listItem );


local listItem = Turbine.UI.Control();
      listItem:SetSize( 600, 45 );
      	listItem.line3_1=Turbine.UI.Label();
	listItem.line3_1:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
      	listItem.line3_1:SetParent(listItem);
	listItem.line3_1:SetSize(100,20);
	listItem.line3_1:SetText("MAP img");

      	listItem.line3_2= Turbine.UI.Lotro.TextBox();
	listItem.line3_2:SetFont(Turbine.UI.Lotro.Font.Verdana16);
      	listItem.line3_2:SetParent(listItem);
	listItem.line3_2:SetSize(450,20);
	listItem.line3_2:SetPosition(150,0);
	listItem.line3_2:SetText(settings.MAPimg[MapID]);
	listItem.line3_2:SetMultiline(false);
      optionsPanel:AddItem( listItem );


local listItem = Turbine.UI.Control();
      listItem:SetSize( 400, 35 );
      	listItem.line4_1=Turbine.UI.Lotro.Button();
      	listItem.line4_1:SetParent(listItem);
	listItem.line4_1:SetSize(60,20);
	listItem.line4_1:SetPosition(150,0);
	listItem.line4_1:SetText("New");
	listItem.line4_1.MouseClick = NewMap;

      	listItem.line4_2=Turbine.UI.Lotro.Button();
      	listItem.line4_2:SetParent(listItem);
	listItem.line4_2:SetSize(60,20);
	listItem.line4_2:SetPosition(220,0);
	listItem.line4_2:SetText("Edit");
	listItem.line4_2.MouseClick = MapEdit;

      	listItem.line4_3=Turbine.UI.Lotro.Button();
      	listItem.line4_3:SetParent(listItem);
	listItem.line4_3:SetSize(60,20);
	listItem.line4_3:SetPosition(290,0);
	listItem.line4_3:SetText("Delete");
	listItem.line4_3.MouseClick = DelMap;


      optionsPanel:AddItem( listItem );

local listItem = Turbine.UI.Control();
      listItem:SetSize( 400, 50 );
      	listItem.line5=Turbine.UI.Label();
	listItem.line5:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
      	listItem.line5:SetParent(listItem);
	listItem.line5:SetSize(400,30);
	listItem.line5:SetText("-------------------------------------------------------");
      optionsPanel:AddItem( listItem );


local listItem = Turbine.UI.Control();
      listItem:SetSize( 400, 35 );
      	listItem.line6=Turbine.UI.Label();
	listItem.line6:SetFont(Turbine.UI.Lotro.Font.TrajanPro24);
      	listItem.line6:SetParent(listItem);
	listItem.line6:SetSize(400,30);
	listItem.line6:SetText("Sub MAP");
	listItem.line6:SetForeColor(Turbine.UI.Color(221/255, 160/255, 221/255));
    	listItem.line6:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
    	listItem.line6:SetFontStyle(Turbine.UI.FontStyle.Outline);
    	listItem.line6:SetOutlineColor(Turbine.UI.Color(0, 0, 0));
    	listItem.line6:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend);
      optionsPanel:AddItem( listItem );

local listItem = Turbine.UI.Control();
      listItem:SetSize( 400, 250 );
        listItem.line7 = Turbine.UI.ListBox();
      	listItem.line7:SetParent( listItem );
      	listItem.line7:SetBackColor( Turbine.UI.Color( 0.2, 0.2, 0.2 ) );
      	listItem.line7:SetSize( 300, 240 );
	listItem.line7:SetPosition(100,0);
	listItem.line7_2 = {};
	for i = 1, table.maxn(settings.SubMAP[MapID]) do
            local listItem1 = Turbine.UI.Control();
            listItem1:SetSize( 300, 20 );
            listItem1:SetBackColor( Turbine.UI.Color(  0.2, 0.2, 0.2) );
		listItem1.Qty=Turbine.UI.Label();
		listItem1.Qty:SetParent(listItem1);
		listItem1.Qty:SetSelectable( true );
		listItem1.Qty:SetSize(300,20);
		listItem1.Qty:SetTop(1);
		listItem1.Qty:SetFont(Turbine.UI.Lotro.Font.Verdana16);
		listItem1.Qty:SetText( settings.SubMAP[MapID][i]);
    		listItem1.Qty.MouseClick = function(sender, args)
        		if (args.Button == Turbine.UI.MouseButton.Left) then
			   listItem = optionsPanel:GetItem(7);
			   listItem.line7_2[SMapID]:SetVisible(false);
      			   listItem.line7_2[SMapID]:SetBackColor( Turbine.UI.Color( 0.2, 0.2, 0.2 ) );
            		   SMapID = listItem.line7:GetSelectedIndex();
			   listItem.line7_2[SMapID]:SetVisible(true);
      			   listItem.line7_2[SMapID]:SetBackColor( Turbine.UI.Color( 106/255, 90/255, 205/255 ) );
			   listItem8 = optionsPanel:GetItem(8);
			   listItem8.line8_2:SetText(settings.BGimg[MapID][SMapID]);
			   optionsPanel:SetItem(8, listItem8 );
			   listItem9 = optionsPanel:GetItem(9);
			   listItem9.line9_2:SetText(settings.NoteCover[MapID][SMapID]);
			   optionsPanel:SetItem(9, listItem9 );
			end
    		end
            listItem.line7:AddItem( listItem1 );

	    listItem.line7_2[i] = Turbine.UI.TextBox();
	    listItem.line7_2[i]:SetMultiline(false);
      	    listItem.line7_2[i]:SetParent( listItem );
      	    listItem.line7_2[i]:SetBackColor( Turbine.UI.Color( 0.2, 0.2, 0.2 ) );
      	    listItem.line7_2[i]:SetSize( 300, 20 );
	    listItem.line7_2[i]:SetPosition(100,(i-1)*20);
	    listItem.line7_2[i]:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	    listItem.line7_2[i]:SetText( settings.SubMAP[MapID][i]);
	    listItem.line7_2[i]:SetVisible(false);
      	end
	listItem.line7_2[SMapID]:SetVisible(true);
      	listItem.line7_2[SMapID]:SetBackColor( Turbine.UI.Color( 106/255, 90/255, 205/255 ) );


      optionsPanel:AddItem( listItem );

local listItem = Turbine.UI.Control();
      listItem:SetSize( 600, 45 );
      	listItem.line8_1=Turbine.UI.Label();
	listItem.line8_1:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
      	listItem.line8_1:SetParent(listItem);
	listItem.line8_1:SetSize(100,20);
	listItem.line8_1:SetText("SubMAP img");

      	listItem.line8_2= Turbine.UI.Lotro.TextBox();
	listItem.line8_2:SetFont(Turbine.UI.Lotro.Font.Verdana16);
      	listItem.line8_2:SetParent(listItem);
	listItem.line8_2:SetSize(450,20);
	listItem.line8_2:SetPosition(150,0);
	listItem.line8_2:SetText(settings.BGimg[MapID][SMapID]);
	listItem.line8_2:SetMultiline(false);
    	listItem.line8_2:SetWantsUpdates(true);
      optionsPanel:AddItem( listItem );


local listItem = Turbine.UI.Control();
      listItem:SetSize( 600, 45 );
      	listItem.line9_1=Turbine.UI.Label();
	listItem.line9_1:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
      	listItem.line9_1:SetParent(listItem);
	listItem.line9_1:SetSize(150,20);
	listItem.line9_1:SetText("SubMAP Note img");

      	listItem.line9_2= Turbine.UI.Lotro.TextBox();
	listItem.line9_2:SetFont(Turbine.UI.Lotro.Font.Verdana16);
      	listItem.line9_2:SetParent(listItem);
	listItem.line9_2:SetSize(450,20);
	listItem.line9_2:SetPosition(150,0);
	listItem.line9_2:SetText(settings.NoteCover[MapID][SMapID]);
	listItem.line9_2:SetMultiline(false);
    	listItem.line9_2:SetWantsUpdates(true);
      optionsPanel:AddItem( listItem );



local listItem = Turbine.UI.Control();
      listItem:SetSize( 600, 40 );
      	listItem.line10_1=Turbine.UI.Lotro.Button();
      	listItem.line10_1:SetParent(listItem);
	listItem.line10_1:SetSize(60,20);
	listItem.line10_1:SetPosition(100,0);
	listItem.line10_1:SetText("New");
	listItem.line10_1.MouseClick = NewSMap;

      	listItem.line10_2=Turbine.UI.Lotro.Button();
      	listItem.line10_2:SetParent(listItem);
	listItem.line10_2:SetSize(60,20);
	listItem.line10_2:SetPosition(170,0);
	listItem.line10_2:SetText("Edit");
	listItem.line10_2.MouseClick = SMapEdit;

      	listItem.line10_3=Turbine.UI.Lotro.Button();
      	listItem.line10_3:SetParent(listItem);
	listItem.line10_3:SetSize(60,20);
	listItem.line10_3:SetPosition(240,0);
	listItem.line10_3:SetText("Delete");
	listItem.line10_3.MouseClick = DelSMap;

      	listItem.line10_4=Turbine.UI.Lotro.Button();
      	listItem.line10_4:SetParent(listItem);
	listItem.line10_4:SetSize(90,20);
	listItem.line10_4:SetPosition(310,0);
	listItem.line10_4:SetText("Move UP");
	listItem.line10_4.MouseClick = SMapUp;

      	listItem.line10_5=Turbine.UI.Lotro.Button();
      	listItem.line10_5:SetParent(listItem);
	listItem.line10_5:SetSize(90,20);
	listItem.line10_5:SetPosition(410,0);
	listItem.line10_5:SetText("Move Down");
	listItem.line10_5.MouseClick = SMapDown;


      optionsPanel:AddItem( listItem );

--------------------------------------------------------------
end